/* code for [re]setting word codes in lc[h] data. */
/** MUST BE COMPILED WITH A FILE DEFINING 'word_id_string()' **/

#define DEBUG    0
#define DEBUG_ALLOC    0
#define DEBUG_INP 0
#define DEBUG_STRUCMOD 0
#define DEBUG_TRIG 0
#define DEBUG_READOUT 0
void bugbreak() {}

#include <stdlib.h>
/* #include "/usr/include/stdlib.h" ?*/
#include <stdio.h>
#include <string.h>

#define MAXLABEL 100  /* max length of label string */
#define MAXDATALINE 10000  /* max length of one line of words */
#define MAXSENTLENGTH 1000
#define MAXWORDLENGTH 100 


/* GLOBAL VARIABLES */

int sentence_number;

/* PROCEDURE DECLARATIONS */

int main(int , char *[]);
char *conv_word_id_string(int , char *);

void usage_error(char *);
void error(char *);

/* EXTERNALLY DEFINED PROCEDURE DECLARATIONS */

char *word_id_string(int , char *);



/* CODE */

/* Parse the command line and do the right thing. */
int main(int argc, char *argv[])
{
  int nextarg;
  int i, b;
  char buffer[MAXDATALINE];
  char *inpp;
  int tag;
  char *word;
  char *oldinp;

  int errno = 0;
  nextarg = 1;
  if (argc > 1 && strcmp(argv[nextarg], "-h") == 0)
    usage_error(argv[0]);

  
#if DEBUG_INP
  printf("\n");
#endif

  while (fgets(buffer, MAXDATALINE, stdin) != NULL)
    {
      for (inpp = buffer; inpp[0] != '\n'; inpp++)
	{
	  if (inpp >= buffer+MAXDATALINE-1)
	    error("Error: no newline found or line too long.");

	  printf("%c", inpp[0]);
	  if (inpp[0] == '>')
	    {
	      inpp++;  /* move over > */
	      inpp++;  /* skip space */
	      oldinp = strtok(inpp, " \t\n"); /* existing tag-word id */
	      word = strtok(NULL, " \t\n"); /* text of word */
	      tag = atoi(strtok(oldinp, ",-;./ \t\n")); /* tag id */
	      printf(" %d", tag); /* output tag */
	      printf("%s %s", conv_word_id_string(tag, word), word);
	      /* output new word id and word text */

	      break; /* loop exit */
	    }
	}
      printf("\n");
    }
  return(errno);
}

void usage_error(char *name)
{
  printf("Usage:  %s (-h)\n  old data to stdin and new to stdout.\n", 
	 name);  
  exit(0);
}

void error(char *mes)
{
  printf("\n%s\n", mes); 
  exit(0);
}

  

/* do string conversion and pass to word_id_string() */
/** should add capitalization and morphological features here **/
char *conv_word_id_string(int tag, char *str)
{
  char word[MAXWORDLENGTH];
  int j, k, m;

  /* keep this in synch with dat2words.c */
  strcpy(word, str);
  /* change to lower case */
  for (j = 0; word[j] != '\0'; j++)
    if (word[j] >= 'A' && word[j] <= 'Z')
      word[j] += ('a' - 'A');
  /* replace numbers with N */
  for (j = 0; word[j] != '\0'; j++)  
    {
      if (word[j] >= '0' && word[j] <= '9')
	{
	  word[j] = 'N';
	  for (k = j + 1; word[k] >= ',' && word[k] <= '9'; k++)
	    {}
	  for (m = j + 1; word[m - 1] != '\0'; m++)
	    {
	      word[m] = word[k];
	      k++;
	    }
	  /* now word[j+1] not a number, but might be more later */
	}		
    }      

  return(word_id_string(tag, word));
}


