/* Written by James Henderson and Ivan Titov */
#ifndef _LIST_H_

#define _LIST_H_

/** struct for list handling */
struct list {
    struct list *next;
    struct list *prev;
    void   *elem;
};

/** 
 * adds elem to the tail of the list
 * @param head head of the list
 * @param tail tail of the list
 * @param elem the elem of the node to add
 */
void add_to_tail(struct list **head, struct list **tail, void *elem);

/** 
 * adds elem to the head of the list
 * @param head head of the list
 * @param tail tail of the list
 * @param elem the elem of the node to add
 */
void add_to_head(struct list **head, struct list **tail, void *elem);

/**
 * gets and removes element from the list head
 * @param head the list head
 * @param tail the list tail
 * @return elem
 */
void* pop_from_head(struct list **head, struct list **tail);

/**
 * gets and removes element from the list tail
 * @param head the list head
 * @param tail the list tail
 * @return elem
 */
void* pop_from_tail(struct list **head, struct list **tail);

/**
 * frees the list (without freeing the elements)
 * @param head head  of the list
 * @param tail tail of the list
 */
void free_list(struct list **head, struct list** tail);

#endif
