/* code for adding word ids to v4 tag id text. */
/** MUST BE COMPILED WITH A FILE DEFINING 'word_id_string()' **/

#define DEBUG    0
void bugbreak() {}

#include <stdlib.h>
/* #include "/usr/include/stdlib.h" ?*/
#include <stdio.h>
#include <math.h>
#include <string.h>

#define MAXDATALINE 10000  /* max length of one line of words */
#define MAXWORDLENGTH 1000


/** GLOBAL VARIABLES **/

int sentence_number;

/** PROCEDURE DECLARATIONS **/

int main(int , char *[]);
char *conv_word_id_string(int , char *);

void usage_error(char *);
void error(char *);

/* EXTERNALLY DEFINED PROCEDURE DECLARATIONS */

char *word_id_string(int , char *);


/** CODE **/

/* Parse the command line and do the right thing. */
int main(int argc, char *argv[])
{
  int nextarg;
  char buffer[MAXDATALINE];
  char *word;
  char *tag;
  char sep;
  int tagid;
  int j, k, m;
  char *pos; 
  int errno = 0;
  nextarg = 1;

  if (argc > 1)
    usage_error(argv[0]);

  while (fgets(buffer, MAXDATALINE, stdin) != NULL) {
    for (pos = buffer; pos[0] != '\0'; pos++) {
      if (pos[0] == ' ' || pos[0] == '\n')
	continue;
      /* word */
      word = pos;
      for (; pos[0] != '\0'; pos++) {
	printf("%c", pos[0]);
	if (pos[0] == '_') {
	  break;
	}
      }
      pos[0] = '\0';
      pos++;
      if (pos[0] == '\0')
	error("line ends while expecting a tag.");
      tag = pos;
      /* tag */
      for (; pos[0] != '\0'; pos++) {
	if (pos[0] == ',' || pos[0] == ' ' || pos[0] == '\n') {
	  break;
	}
	else {
	  printf("%c", pos[0]);
	}
      }
      sep = pos[0];
      pos[0] = '\0';
      tagid = atoi(tag);
      pos[0] = sep;
      /* other wordids */
      for (; pos[0] != '\0'; pos++) {
	if (pos[0] == ' ' || pos[0] == '\n') {
	  break;
	}
	else {
	  printf("%c", pos[0]);
	}
      }
      /* new wordid position */
      printf("%s", conv_word_id_string(tagid, word));
      printf("%c", pos[0]);
    }
    printf("\n");
    fflush(stdout);
  }
   
  return(errno);
}


void usage_error(char *name)
{
  printf("Usage:\n  %s [-h]\n tagged words in stdin, tag-word ids to stdout\n", 
	 name);  
  exit(0);
}

void error(char *mes)
{
  printf("\n%s\n", mes); 
  exit(0);
}

  

/* do string conversion and pass to word_id_string() */
/** should add capitalization and morphological features here **/
char *conv_word_id_string(int tag, char *str)
{
  char word[MAXWORDLENGTH];
  int j, k, m;

  /* keep this in synch with dat2words.c */
  strcpy(word, str);
  /* change to lower case */
  for (j = 0; word[j] != '\0'; j++)
    if (word[j] >= 'A' && word[j] <= 'Z')
      word[j] += ('a' - 'A');
  /* replace numbers with N */
  for (j = 0; word[j] != '\0'; j++)  
    {
      if (word[j] >= '0' && word[j] <= '9')
	{
	  word[j] = 'N';
	  for (k = j + 1; word[k] >= ',' && word[k] <= '9'; k++)
	    {}
	  for (m = j + 1; word[m - 1] != '\0'; m++)
	    {
	      word[m] = word[k];
	      k++;
	    }
	  /* now word[j+1] not a number, but might be more later */
	}		
    }      

  return(word_id_string(tag, word));
}
