/* code for changing tagged text to v4 tag id text. */


#define DEBUG    0
void bugbreak() {}

#include <stdlib.h>
/* #include "/usr/include/stdlib.h" ?*/
#include <stdio.h>
#include <math.h>
#include <string.h>

#define MAXDATALINE 10000  /* max length of one line of words */



/** TAG CODES **/

int tag_id(char *str)
{
  if (!strcmp(str, "#"))
    return(0);
  else if (!strcmp(str, "$"))
    return(1);
  else if (!strcmp(str, "''"))
    return(2);
  else if (!strcmp(str, ","))
    return(3);
  else if (!strcmp(str, "-LRB-"))
    return(4);
  else if (!strcmp(str, "-RRB-"))
    return(5);
  else if (!strcmp(str, "."))
    return(6);
  else if (!strcmp(str, ":"))
    return(7);
  else if (!strcmp(str, "^^^"))
    return(8);
  else if (!strcmp(str, "``"))
    return(9);
  else if (!strcmp(str, "CC"))
    return(10);
  else if (!strcmp(str, "CD"))
    return(11);
  else if (!strcmp(str, "DT"))
    return(12);
  else if (!strcmp(str, "EX"))
    return(13);
  else if (!strcmp(str, "FW"))
    return(14);
  else if (!strcmp(str, "IN"))
    return(15);
  else if (!strcmp(str, "JJ"))
    return(16);
  else if (!strcmp(str, "JJR"))
    return(17);
  else if (!strcmp(str, "JJS"))
    return(18);
  else if (!strcmp(str, "LS"))
    return(19);
  else if (!strcmp(str, "MD"))
    return(20);
  else if (!strcmp(str, "NN"))
    return(21);
  else if (!strcmp(str, "NNP"))
    return(22);
  else if (!strcmp(str, "NNPS"))
    return(23);
  else if (!strcmp(str, "NNS"))
    return(24);
  else if (!strcmp(str, "PDT"))
    return(25);
  else if (!strcmp(str, "POS"))
    return(26);
  else if (!strcmp(str, "PRP"))
    return(27);
  else if (!strcmp(str, "PRP$"))
    return(28);
  else if (!strcmp(str, "RB"))
    return(29);
  else if (!strcmp(str, "RBR"))
    return(30);
  else if (!strcmp(str, "RBS"))
    return(31);
  else if (!strcmp(str, "RP"))
    return(32);
  else if (!strcmp(str, "SYM"))
    return(33);
  else if (!strcmp(str, "TO"))
    return(34);
  else if (!strcmp(str, "UH"))
    return(35);
  else if (!strcmp(str, "VB"))
    return(36);
  else if (!strcmp(str, "VBD"))
    return(37);
  else if (!strcmp(str, "VBG"))
    return(38);
  else if (!strcmp(str, "VBN"))
    return(39);
  else if (!strcmp(str, "VBP"))
    return(40);
  else if (!strcmp(str, "VBZ"))
    return(41);
  else if (!strcmp(str, "WDT"))
    return(42);
  else if (!strcmp(str, "WP"))
    return(43);
  else if (!strcmp(str, "WP$"))
    return(44);
  else if (!strcmp(str, "WRB"))
    return(45);
  else
    {
      fprintf(stderr, "Error: unrecognized tag %s\n", str);
      return(99);
    }
}

/** GLOBAL VARIABLES **/

int sentence_number;

/** PROCEDURE DECLARATIONS **/

int main(int , char *[]);

void usage_error(char *);
void error(char *);



/** CODE **/

/* Parse the command line and do the right thing. */
int main(int argc, char *argv[])
{
  int nextarg;
  char buffer[MAXDATALINE];
  char *word;
  char *tag;
  int tagid;
  int wordid;
  int j, k, m;

  int errno = 0;
  nextarg = 1;

  if (argc > 1)
    usage_error(argv[0]);

  while (fgets(buffer, MAXDATALINE, stdin) != NULL) {
    word = strtok(buffer, "_ \n\t");
    while (word != NULL) {
#if DEBUG
	printf(" [%s/", word);
#endif
      if ((tag = strtok(NULL, " \n\t")) != NULL) {
#if DEBUG
	printf("%s] ", tag);
#endif
	tagid = tag_id(tag);
	printf("%s_%d ", word, tagid);
      }
      else
	error("Error: empty tag for existing word.");
      word = strtok(NULL, "_ \n\t");
    }
    printf("\n");
    fflush(stdout);
  }
   
  return(errno);
}


void usage_error(char *name)
{
  printf("Usage:\n  %s [-h]\n tagged words in stdin, words with tag-ids to stdout\n", 
	 name);  
  exit(0);
}

void error(char *mes)
{
  printf("\n%s\n", mes); 
  exit(0);
}

  

